Index: trunk/src/NTDLL/makefile
===================================================================
--- trunk/src/NTDLL/makefile	(revision 603)
+++ trunk/src/NTDLL/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.8 1999-08-18 19:35:30 phaller Exp $
+# $Id: makefile,v 1.9 1999-08-21 12:29:28 sandervl Exp $
 
 #
@@ -41,5 +41,5 @@
 
 $(TARGET).dll: $(OBJS) $(TARGET).def
-        $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) sbsstub.obj $(TARGET).def $(PDWIN32_LIB)\kernel32.lib $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+        $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) sbsstub.obj $(TARGET).def $(PDWIN32_LIB)\kernel32.lib $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 # PMWINX.LIB LIBULS.LIB LIBCONV.LIB
         $(CP) $@ $(PDWIN32_BIN)
Index: trunk/src/advapi32/makefile
===================================================================
--- trunk/src/advapi32/makefile	(revision 603)
+++ trunk/src/advapi32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.9 1999-08-16 16:28:01 sandervl Exp $
+# $Id: makefile,v 1.10 1999-08-21 12:29:28 sandervl Exp $
 
 #
@@ -15,5 +15,5 @@
 
 CFLAGS = $(CFLAGS) -I$(PDWIN32_INCLUDE)
-CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE)
+CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE) /Ls /Le
 
 
@@ -29,5 +29,5 @@
 	$(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
               $(PDWIN32_LIB)/kernel32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/capi2032/makefile
===================================================================
--- trunk/src/capi2032/makefile	(revision 603)
+++ trunk/src/capi2032/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:01 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:28 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
 	$(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/comctl32/makefile
===================================================================
--- trunk/src/comctl32/makefile	(revision 603)
+++ trunk/src/comctl32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.13 1999-08-16 16:28:02 sandervl Exp $
+# $Id: makefile,v 1.14 1999-08-21 12:29:29 sandervl Exp $
 #
 # PD-Win32 API
@@ -37,5 +37,5 @@
               $(PDWIN32_LIB)/gdi32.lib \
               $(PDWIN32_LIB)/user32.lib  $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB  $(RTLLIB_O)
               rc rsrc.res comctl32.dll
         $(CP) $@ $(PDWIN32_BIN)
Index: trunk/src/comdlg32/makefile
===================================================================
--- trunk/src/comdlg32/makefile	(revision 603)
+++ trunk/src/comdlg32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.6 1999-08-16 16:28:02 sandervl Exp $
+# $Id: makefile,v 1.7 1999-08-21 12:29:29 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB $(RTLLIB_O)
         $(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/ddraw/makefile
===================================================================
--- trunk/src/ddraw/makefile	(revision 603)
+++ trunk/src/ddraw/makefile	(revision 604)
@@ -22,5 +22,5 @@
         
 
-LIBS =  ..\..\lib\pmwinx.lib mmpm2.lib ..\..\lib\comctl32.lib $(PDWIN32_LIB)\advapi32.lib $(PDWIN32_LIB)\kernel32.lib $(PDWIN32_LIB)\gdi32.lib $(PDWIN32_LIB)\comctl32.lib $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+LIBS =  ..\..\lib\pmwinx.lib mmpm2.lib ..\..\lib\comctl32.lib $(PDWIN32_LIB)\advapi32.lib $(PDWIN32_LIB)\kernel32.lib $(PDWIN32_LIB)\gdi32.lib $(PDWIN32_LIB)\comctl32.lib $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 
 all: $(TARGET).dll $(TARGET).lib
Index: trunk/src/dsound/makefile
===================================================================
--- trunk/src/dsound/makefile	(revision 603)
+++ trunk/src/dsound/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:02 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:29 sandervl Exp $
 
 #
@@ -29,5 +29,5 @@
         $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
               pmwinx.lib  $(PDWIN32_LIB)/kernel32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         $(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/gdi32/makefile
===================================================================
--- trunk/src/gdi32/makefile	(revision 603)
+++ trunk/src/gdi32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:02 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:29 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
 	$(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/kernel32/makefile
===================================================================
--- trunk/src/kernel32/makefile	(revision 603)
+++ trunk/src/kernel32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.21 1999-08-19 19:50:40 sandervl Exp $
+# $Id: makefile,v 1.22 1999-08-21 12:29:30 sandervl Exp $
 
 #
@@ -84,5 +84,5 @@
 
 $(TARGET).dll: $(OBJS) $(TARGET).def
-        $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def $(PDWIN32_LIB)\PMWINX.LIB $(PDWIN32_LIB)\LIBULS.LIB $(PDWIN32_LIB)\LIBCONV.LIB $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+        $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def $(PDWIN32_LIB)\PMWINX.LIB $(PDWIN32_LIB)\LIBULS.LIB $(PDWIN32_LIB)\LIBCONV.LIB $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         rc -r console.rc console.res
         rc console.res $@
Index: trunk/src/lz32/makefile
===================================================================
--- trunk/src/lz32/makefile	(revision 603)
+++ trunk/src/lz32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.3 1999-08-17 19:30:50 phaller Exp $
+# $Id: makefile,v 1.4 1999-08-21 12:29:30 sandervl Exp $
 
 #
@@ -31,5 +31,5 @@
         $(PDWIN32_LIB)\kernel32.lib \
         os2386.lib \
-        sbsstub.obj \
+        $(RTLLIB_O) \
         $(TARGET).def
         $(CP) $@ $(PDWIN32_BIN)
Index: trunk/src/mpr/makefile
===================================================================
--- trunk/src/mpr/makefile	(revision 603)
+++ trunk/src/mpr/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:03 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:30 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/ole32/makefile
===================================================================
--- trunk/src/ole32/makefile	(revision 603)
+++ trunk/src/ole32/makefile	(revision 604)
@@ -37,5 +37,5 @@
               $(PDWIN32_LIB)\advapi32.lib \
               $(PDWIN32_LIB)\kernel32.lib \
-               $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+               $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 #              $(PDWIN32_LIB)\ntdll.lib \
Index: trunk/src/pe2lx/makefile
===================================================================
--- trunk/src/pe2lx/makefile	(revision 603)
+++ trunk/src/pe2lx/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.8 1999-08-16 16:28:03 sandervl Exp $
+# $Id: makefile,v 1.9 1999-08-21 12:29:30 sandervl Exp $
 
 #
@@ -32,6 +32,5 @@
 $(TARGET).exe: $(OBJS)
 	$(LD) $(LDFLAGS) -Fe$@ $(OBJS) \
-#        $(PDWIN32_LIB)\LIBCONV.LIB $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
-        $(PDWIN32_LIB)\LIBCONV.LIB OS2386.LIB cppom30.lib
+        $(PDWIN32_LIB)\LIBCONV.LIB $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         $(CP) $(TARGET).exe $(PDWIN32_BIN)
 
Index: trunk/src/peldr/makefile
===================================================================
--- trunk/src/peldr/makefile	(revision 603)
+++ trunk/src/peldr/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.6 1999-08-16 16:28:03 sandervl Exp $
+# $Id: makefile,v 1.7 1999-08-21 12:29:31 sandervl Exp $
 
 #
@@ -18,5 +18,5 @@
 CXXFLAGS = $(CXXFLAGS) /Ge+ -I$(PDWIN32_INCLUDE)
 LDFLAGSEXE = $(LDFLAGS) /Ge+ /B"/pmtype:pm /stack:0x30000 /NOBASE /Map" \
-             $(PDWIN32_LIB)\peldr.lib os2386.lib $(PDWIN32_LIB)\odincrt.lib cppom30O.lib
+             $(PDWIN32_LIB)\peldr.lib os2386.lib $(PDWIN32_LIB)\odincrt.lib $(RTLLIB_O)
 
 
@@ -35,5 +35,5 @@
 
 $(TARGETDLL).dll: $(OBJSDLL) $(TARGETDLL).def 
-	$(LD) $(LDFLAGS) -Fe$@ $(OBJSDLL) sbsstub.obj $(TARGETDLL).def OS2386.LIB CPPOM30.LIB
+	$(LD) $(LDFLAGS) -Fe$@ $(OBJSDLL) $(TARGETDLL).def OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/shell32/makefile
===================================================================
--- trunk/src/shell32/makefile	(revision 603)
+++ trunk/src/shell32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.9 1999-08-16 16:28:03 sandervl Exp $
+# $Id: makefile,v 1.10 1999-08-21 12:29:31 sandervl Exp $
 
 #
@@ -31,5 +31,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/advapi32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         $(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/tapi32/makefile
===================================================================
--- trunk/src/tapi32/makefile	(revision 603)
+++ trunk/src/tapi32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:04 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:31 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/user32/Makefile
===================================================================
--- trunk/src/user32/Makefile	(revision 603)
+++ trunk/src/user32/Makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.14 1999-08-19 12:53:55 sandervl Exp $
+# $Id: Makefile,v 1.15 1999-08-21 12:29:31 sandervl Exp $
 
 #
@@ -35,5 +35,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/gdi32.lib \
               $(PDWIN32_LIB)/kernel32.lib $(PDWIN32_LIB)/libuls.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         $(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/user32/new/makefile
===================================================================
--- trunk/src/user32/new/makefile	(revision 603)
+++ trunk/src/user32/new/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.27 1999-08-20 20:09:51 sandervl Exp $
+# $Id: makefile,v 1.28 1999-08-21 12:29:31 sandervl Exp $
 
 #
@@ -42,5 +42,5 @@
         $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/gdi32.lib $(PDWIN32_LIB)/kernel32.lib $(PDWIN32_LIB)/libuls.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
         rc $(TARGET).res $(TARGET).dll
         $(CP) $@ $(PDWIN32_BIN)
Index: trunk/src/version/makefile
===================================================================
--- trunk/src/version/makefile	(revision 603)
+++ trunk/src/version/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.6 1999-08-16 16:28:04 sandervl Exp $
+# $Id: makefile,v 1.7 1999-08-21 12:29:32 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              $(PDWIN32_LIB)/lz32.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/lz32.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/winmm/makefile
===================================================================
--- trunk/src/winmm/makefile	(revision 603)
+++ trunk/src/winmm/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.7 1999-08-16 16:28:04 sandervl Exp $
+# $Id: makefile,v 1.8 1999-08-21 12:29:32 sandervl Exp $
 
 #
@@ -36,5 +36,5 @@
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
               OS2386.LIB \
-              cppom30O.lib
+              $(RTLLIB_O)
         $(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/winspool/makefile
===================================================================
--- trunk/src/winspool/makefile	(revision 603)
+++ trunk/src/winspool/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:05 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:32 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/wnetap32/makefile
===================================================================
--- trunk/src/wnetap32/makefile	(revision 603)
+++ trunk/src/wnetap32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 1999-08-16 16:28:05 sandervl Exp $
+# $Id: makefile,v 1.6 1999-08-21 12:29:32 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)/pmwinx.lib $(PDWIN32_LIB)/kernel32.lib \
               $(PDWIN32_LIB)/user32.lib $(PDWIN32_LIB)/odincrt.lib \
-              OS2386.LIB cppom30O.lib
+              OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 
Index: trunk/src/wsock32/makefile
===================================================================
--- trunk/src/wsock32/makefile	(revision 603)
+++ trunk/src/wsock32/makefile	(revision 604)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.6 1999-08-16 16:28:05 sandervl Exp $
+# $Id: makefile,v 1.7 1999-08-21 12:29:32 sandervl Exp $
 
 #
@@ -30,5 +30,5 @@
               $(PDWIN32_LIB)\pmwinx.lib $(PDWIN32_LIB)\user32.lib \
               tcp32dll.lib so32dll.lib  $(PDWIN32_LIB)\kernel32.lib \
-              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB cppom30O.lib
+              $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
 	$(CP) $@ $(PDWIN32_BIN)
 