Index: trunk/README.OS2
===================================================================
--- trunk/README.OS2	(revision 576)
+++ trunk/README.OS2	(revision 624)
@@ -337,5 +337,32 @@
 
   QT_PM_REGISTRY            The opposite to the above. If set, Qt will use the
-                            Open32 registry to store application settings.
+                            Open32 registry to store application settings. This
+                            variable is ignored if QT_PM_NO_REGISTRY is set.
+
+  QT_PM_NO_SYSTEM_LOCALE    If set, Qt will ignore the regional settings from
+                            the system locale object found in the Country
+                            Palette located in the System Setup folder and will
+                            take them from the internal Qt locale database
+                            according to the current country and language
+                            settings. Due to the fact that this internal Qt
+                            database usually has a better representation of the
+                            regional settings, this is the default behavior if
+                            neither this nor the QT_PM_SYSTEM_LOCALE variable is
+                            set.
+
+  QT_PM_SYSTEM_LOCALE       The opposite to the above. If set, Qt will use the
+                            regional settings as found in the default locale
+                            object set the Country Palette.  This variable is
+                            ignored if QT_PM_NO_SYSTEM_LOCALE is set.
+
+  LANG                      This variable can be used to override the default
+                            country and language used in the Qt application both
+                            for regional settings and for translations. The
+                            format of the value is "ll_CC" where <ll> is the
+                            two-letter ISO language code and <CC> is the two-
+                            letter ISO country code. Note that if this variable
+                            is not set, Qt will derive the language and country
+                            from the system country code specified in the
+                            COUNTRY statement of CONFIG.SYS.
 
 
@@ -373,23 +400,8 @@
      Qt.
 
-  4. In order to let Qt correctly detect the regional settings and choose the
-     right language for translating the user interface, the LANG environment
-     variable must be set. The format is
-
-       set LANG=ll_CC
-
-     where <ll> is the language code and <CC> is the country code (refer to
-     wikipedia.org to find correct letters for your langage and country if you
-     do not know them). Note that the optional encoding part of the LANG
-     specification is ignored by Qt for OS/2 since 4.5.1 Beta 5 because it now
-     detects the encoding automatically based on the system OS/2 settings.
-
-     Later, the correct language will be detected from the system settings so
-     that specifying LANG will be not necessary at all.
-
-  5. No qt3support module. This functionality is rarely necessary in mature
+  4. No qt3support module. This functionality is rarely necessary in mature
      real life applications and has low priority.
 
-  6. No native PM style, but Qt will use fonts and colors from the current
+  5. No native PM style, but Qt will use fonts and colors from the current
      OS/2 theme. Hint: if your default OS/2 font is "WarpSans", install the
      "Workplace Sans" TTF font from Alex Taylor to get more native look & feel.
@@ -399,9 +411,9 @@
        http://users.socis.ca/~ataylo00/creative/fonts/workplace/
 
-  7. QProcess: when starting PM applications from text-mode applications, the
+  6. QProcess: when starting PM applications from text-mode applications, the
      returned PID is a PID of the intermediate cmd.exe process, not the target
      application.
 
-  8. The followign classes are not available due to their rare usage or low
+  7. The followign classes are not available due to their rare usage or low
      importance on the OS/2 platform: QSharedMemory, QSystemSemaphore,
      QInputContext, QAccessible. The following macros are defined to indicate
@@ -410,5 +422,5 @@
      relevant parts of code so they should still build.
 
-  9. No QAssistant. No IPV6 support in the network module (QT_NO_IPV6 is
+  8. No QAssistant. No IPV6 support in the network module (QT_NO_IPV6 is
      defined).
 